C 1997/9
C               BOUNDARY ELEMENT METHOD
C       FOR TWO-DIMENSIONAL ELASTICITY PROBLEMS
C           USING SUPERPOSITION CALCULATION
C         ------- I2V3000 FOR WINDOWS95 -------
C                   BY TAKAYUKI HIRAI 
C
      COMMON M(3000),R(3000),F(3000),AP(3000,2),CG(4,9,3),
     1   Q(5,2,2),QQ(2,2,2,2,2),ZP,ZI,TH,EN,PR,UU,VV,LE
     2   ,LF,LBB,FUV
      COMMON /A/SP(400,2),C(400,5),NSP(20),NEG(20),JA(20),
     1   JB(20),IP(20),PRR(20),ENN(20),THH(20),JAA(20,20),
     2   JBB(20,20),SSG(20)
      COMMON /B/DP(3000,2),MD(3000),MM(3000),PT(3000,2,2),
     1   PD(3000,2,2),P(3000,2,2),PP(3000,2,4)
      COMMON /C/G(12000,12000),B(12000),SXTB1(20),SXTB2(20),
     1   SYTB1(20),SYTB2(20) 
      CHARACTER TITLE*5
C
C  ------------------- INPUT DATA -----------------
C  NG IS THE DIMENSION OF G-MATRIX
      NG=12000
      OPEN (15,FILE='DD')
      OPEN (16,FILE='R1')
      ZP=3.141593
      ZI=1.0/ZP
      CG(1,1,1)=0.7745967
      CG(1,1,2)=0.5555556
      CG(1,2,2)=0.8888889
      CG(2,1,1)=0.9061798
      CG(2,2,1)=0.5384693
      CG(2,1,2)=0.2369269
      CG(2,2,2)=0.4786287
      CG(2,3,2)=0.5688889
      CG(3,1,1)=0.9491079
      CG(3,2,1)=0.7415312
      CG(3,3,1)=0.4058452
      CG(3,1,2)=0.1294850
      CG(3,2,2)=0.2797054
      CG(3,3,2)=0.3818301
      CG(3,4,2)=0.4179592
      DO 11 K1=1,3
      CG(K1,K1+1,1)=0.0
      K2=K1+2
      K3=K1*2+1
      DO 13 K4=K2,K3
      CG(K1,K4,2)=CG(K1,K3+1-K4,2)
   13 CG(K1,K4,1)=-CG(K1,K3+1-K4,1)
      DO 11 K4=1,K3
   11 CG(K1,K4,3)=CG(K1,K4,1)*CG(K1,K4,2)
      NCR=0
      KPR=0
      READ(15,1001) TITLE,NE,ND,NS,XS,YS,XYS,
     1    (NSP(J),J=1,10)
      IF(ND*4.GT.NG) NCR=9600
      IF(NS.GT.400) NCR=9500
      IF(NE.GT.10) NCR=9000
      WRITE(0,2101) TITLE
 2101 FORMAT(/,'   START   MODEL =',A5)
      WRITE(16,2001) TITLE,NE,ND,NS,XS,YS,XYS,
     1    (NSP(J),J=1,10)
      DO 12 I=1,NE
      READ(15,1005) NEG(I),PRR(I),ENN(I),THH(I),
     1    IP(I),SSG(I),(JBB(I,J),J=1,10)
      IF(NEG(I).GT.10) NCR=9400
      IF (THH(I).LT.0.00001) NCR=9100  
      IF (ENN(I).LT.0.00001) NCR=9200     
      IF(IP(I).EQ.1) GO TO 17
      IF(PRR(I).GE.1.0) NCR=9300  
      IF(PRR(I).GE.0.33) KPR=9
      GO TO 12
   17 IF(PRR(I).GE.0.5) NCR=9300  
      IF(PRR(I).GE.0.25) KPR=9
   12 WRITE(16,2005) I,NEG(I),PRR(I),ENN(I),THH(I),
     1    IP(I),SSG(I),(JBB(I,J),J=1,10)
      DO 10 I=1,ND
   10 READ(15,1002,END=78) M(I),N,MM(I),MD(I),(DP(I,J),J=
     1    1,2),((P(I,J,L),L=1,2),J=1,2)
      IF(NS.EQ.0) GO TO 39 
      DO 16 I=1,NS
   16 READ(15,1004,END=79) N,SP(I,1),SP(I,2)
      GO TO 39
   78 NCR=9700
      GO TO 14
   79 NCR=9800
      GO TO 14
 1001 FORMAT (A5,3I5,3F10.5/16I5)
 1005 FORMAT (I5,F10.5,F10.2,F10.5,I5,F10.7/16I5)
 1002 FORMAT (I1,I4,2I5,6F10.5)
 1004 FORMAT (I5,2F10.5)
 2001 FORMAT (/10X,'MODEL ',A5,15X,'---- SOLUTION BY I2',
     1    'V3000 ----'///'   BLOCK',I5,4X,'BOUNDARY EL',
     2    'EMENT',I6,'   INNER POINT',I6,'   INITIAL S',
     3    'TRESS X-Y-XY',3F12.5/11X,'LAST NO. OF INNER',
     4    ' POINTS IN EACH BLOCK',5X,16I5)
 2005 FORMAT (//,'   BLOCK NO.',I4,'   EDGE',I6,
     1    '   POISSON''S RATIO',F10.5,'   YOUNG''S '
     2    ,'MODULUS',E15.7,'   THICKNESS',F11.5,
     3    '    IP(I)',I4/11X,'INITIAL STRAIN ',F10.7
     4    /11X,'LAST NO. OF BOUNDARY ELEMENTS ON EA',
     5    'CH EDGE     ',16I5)
C
C  --------- ARRANGE BOUNDARY ELEMENTS ---------
   39 JAA(1,1)=1
      DO 20 I=1,NE
      LL=NEG(I)
      IF (I.NE.1) LM=NEG(I-1)
      DO 20 J=1,LL
      IF (J.NE.1) JAA(I,J)=JBB(I,J-1)+1
      IF (I*J.EQ.1) GO TO 20
      IF (J.EQ.1) JAA(I,J)=JBB(I-1,LM)+1
   20 CONTINUE
      DO 21 I=1,NE
      LL=NEG(I)
      JA(I)=JAA(I,1)
      JB(I)=JBB(I,LL)
      DO 21 K=1,LL
      KA=JAA(I,K)
      KB=JBB(I,K)
      DO 21 J=KA,KB
      IF (J.EQ.KB) GO TO 22
      X1=DP(J+1,1)
      X0=DP(J,1)
      Y1=DP(J+1,2)
      Y0=DP(J,2)
      GO TO 23
   22 X1=DP(KA,1)
      X0=DP(KB,1)
      Y1=DP(KA,2)
      Y0=DP(KB,2)
   23 UU=X1-X0
      VV=Y1-Y0
      R(J)=SQRT(UU**2+VV**2)*0.5
      IF (R(J).LT.0.00001) NCR=J
      AP(J,1)=DP(J,1)+0.5*UU
      AP(J,2)=DP(J,2)+0.5*VV
      CALL ARCTAN
   21 F(J)=FUV
      DO 71 I=1,NE
      LL=NEG(I)
      JA(I)=JAA(I,1)
      JB(I)=JBB(I,LL)
      DO 71 K=1,LL
      KA=JAA(I,K)
      KB=JBB(I,K)
      DO 71 J=KA,KB
      JQ1=J-2
      JQ2=J-1
      JQ4=J+1
      IF(J.EQ.KA+1) JQ1=KB
      IF(J.EQ.KB) JQ4=KA
      IF(J.NE.KA) GO TO 72
      JQ1=KB-1
      JQ2=KB
   72 IF(SIN(F(J)-F(JQ2)).GT.0.00001) GO TO 71
      IF(COS(F(J)-F(JQ2)).GT.0.81915) GO TO 71
      IF(ABS(SIN(F(JQ2)-F(JQ1))).GT.0.00001) GO TO 71
      IF(ABS(SIN(F(JQ4)-F(J))).GT.0.00001) GO TO 71
      IF(M(J).GE.3) GO TO 77
      M(J)=2
   77 IF(M(JQ2).GE.3) GO TO 71
      M(JQ2)=1
   71 CONTINUE
      DO 24 L=1,NE
      IF (IP(L).EQ.1) ENN(L)=ENN(L)/(1.0-PRR(L)**2)
      IF (IP(L).EQ.1) PRR(L)=PRR(L)/(1.0-PRR(L))
      LL=NEG(L)
      DO 25 K=1,LL
      WRITE(16,2011) L,K,JAA(L,K),JBB(L,K)
      KA=JAA(L,K)
      KB=JBB(L,K)
      DO 25 I=KA,KB
      FW=F(I)*ZI*180.0
      RRR=2.0*R(I)
   25 WRITE(16,2012) M(I),I,MM(I),MD(I),(DP(I,J),J
     1 =1,2),((P(I,J,N),N=1,2),J=1,2),RRR,FW
      TH=THH(L)
      EN=ENN(L)
      PR=PRR(L)
      S4=SSG(L)*EN/(1.0-PR)
      EX=(XS-PR*YS)/EN
      EY=(YS-PR*XS)/EN
      EXY=XYS*2.0*(1.0+PR)/EN
      LA=1
      LB=NSP(L)
      IF(LB.EQ.0) GO TO 62
      IF (L.NE.1) LA=NSP(L-1)+1
      DO 36 J=LA,LB
      C(J,1)=XS-S4
      C(J,2)=YS-S4
      C(J,3)=XYS
      C(J,4)=EX*SP(J,1)+EXY*SP(J,2)
   36 C(J,5)=EY*SP(J,2)
   62 KA=JA(L)
      KB=JB(L)
      DO 29 I=KA,KB
      DO 35 KS=1,4
      DP(KS,1)=0.0
   35 DP(KS,2)=0.0
      DO 34 J=KA,KB
      IF (MD(J).GE.0) GO TO 34
      LF=J
      SF=SIN(F(J))
      CF=COS(F(J))
      IF (I.NE.1) GO TO 31
      SS=SF*SF
      SSS=2.0*SF*CF
      CC=CF*CF
      CCC=2.0*CC-1.0
      DO 30 N=LA,LB
      UU= (SP(N,1)-AP(J,1))*CF+(SP(N,2)-AP(J,2))*SF
      VV=-(SP(N,1)-AP(J,1))*SF+(SP(N,2)-AP(J,2))*CF
      CALL CONCEN
      X=Q(1,1,1)*P(J,1,1)+Q(1,2,1)*P(J,2,1)
      Y=Q(2,1,1)*P(J,1,1)+Q(2,2,1)*P(J,2,1)
      XY=-Q(3,1,1)*P(J,1,1)-Q(3,2,1)*P(J,2,1)
      C(N,1)=C(N,1)+(X*CC+Y*SS-XY*SSS)/TH
      C(N,2)=C(N,2)+(X*SS+Y*CC+XY*SSS)/TH
      C(N,3)=C(N,3)+(0.5*(X-Y)*SSS+XY*CCC)/TH
      C(N,4)=C(N,4)+((Q(4,1,1)*P(J,1,1)+Q(4,2,1)*
     1    P(J,2,1))*CF-(Q(5,1,1)*P(J,1,1)+Q(5,2,1)
     2    *P(J,2,1))*SF)/TH
   30 C(N,5)=C(N,5)+((Q(4,1,1)*P(J,1,1)+Q(4,2,1)*
     1   P(J,2,1))*SF+(Q(5,1,1)*P(J,1,1)+Q(5,2,1)
     2    *P(J,2,1))*CF)/TH
   31 IF (I.NE.J) GO TO 33
      DP(3,1)=DP(3,1)-4.0*ZI*(ALOG(R(J))-1.0)/EN
     1    *P(J,1,1)/TH
      DP(4,1)=DP(4,1)+(1.0-PR)*0.5/EN*P(J,2,1)/TH
      DP(3,2)=DP(3,2)-2.0*(2.0*ALOG(R(J))-1.0+PR)
     1    *ZI/EN*P(J,2,1)/TH
      DP(4,2)=DP(4,2)+0.5*(PR-1.0)/EN*P(J,1,1)/TH
      GO TO 34
   33 SW=SIN(F(J)-F(I))
      CW=COS(F(J)-F(I))
      SS=SW*SW
      CC=CW*CW
      SSW=2.0*SW*CW
      CCW=2.0*CC-1.0
      XX= (AP(I,1)-AP(J,1))*CF+(AP(I,2)-AP(J,2))*SF
      YY=-(AP(I,1)-AP(J,1))*SF+(AP(I,2)-AP(J,2))*CF
      RA=R(J)
      IF (RA.LT.R(I)) RA=R(I)
      RB=SQRT(XX**2+YY**2)
      NI=3
      IF (RB.GT.6.0*RA) NI=2
      IF (RB.GT.12.0*RA) NI=1
      NJ=NI*2+1
      DO 38 KS=1,NJ
      RRRR=R(I)*CG(NI,KS,1)
      UU=XX+RRRR*CW
      VV=YY-RRRR*SW
      CALL CONCEN
      DO 38 KP=1,2
      WY=(Q(1,KP,1)*SS+Q(2,KP,1)*CC-Q(3,KP,1)*SSW)
     1    *P(J,KP,1)
      WX=(0.5*(Q(1,KP,1)-Q(2,KP,1))*SSW-Q(3,KP,1)
     1    *CCW)*P(J,KP,1)
      DY=(Q(4,KP,1)*SW+Q(5,KP,1)*CW)*P(J,KP,1)/TH
      DX=(Q(4,KP,1)*CW-Q(5,KP,1)*SW)*P(J,KP,1)/TH
      DP(1,1)=DP(1,1)+WX*CG(NI,KS,2)
      DP(1,2)=DP(1,2)+WY*CG(NI,KS,2)
      DP(2,1)=DP(2,1)+WX*CG(NI,KS,3)
      DP(2,2)=DP(2,2)+WY*CG(NI,KS,3)
      DP(3,1)=DP(3,1)+DX*CG(NI,KS,2)
      DP(3,2)=DP(3,2)+DY*CG(NI,KS,2)
      DP(4,1)=DP(4,1)+DX*CG(NI,KS,3)
      DP(4,2)=DP(4,2)+DY*CG(NI,KS,3)
   38 CONTINUE
   34 CONTINUE
      DO 29 KQ=1,2
      PP(I,KQ,1)=(DP(1,KQ)-DP(2,KQ)*3.0)*0.5
      PP(I,KQ,2)=(DP(1,KQ)+DP(2,KQ)*3.0)*0.5
      PP(I,KQ,3)=(DP(3,KQ)-DP(4,KQ)*3.0)*0.5
   29 PP(I,KQ,4)=(DP(3,KQ)+DP(4,KQ)*3.0)*0.5
      DO 24 I=KA,KB
      CC=COS(-0.5*ZP-F(I))
      SS=SIN(-0.5*ZP-F(I))
      AA= XS*CC*CC+YS*SS*SS+XYS*SS*CC*2.0
      BB= (YS-XS)*SS*CC+XYS*(CC*CC*2.0-1.0)
      DX=EX*AP(I,1)+EXY*AP(I,2)
      DY=EY*AP(I,2)
      DO 24 J=1,2
      PT(I,1,J)=BB*TH+PP(I,1,J)
      PT(I,2,J)=AA*TH+PP(I,2,J)-S4*TH
      IF (MD(I).LT.0) PT(I,1,J)=PT(I,1,J)+P(I,1,J)
      IF (MD(I).LT.0) PT(I,2,J)=PT(I,2,J)+P(I,2,J)
      PD(I,2,J)= DX*CC-DY*SS+PP(I,2,J+2)
      PD(I,1,J)=-DX*SS-DY*CC+PP(I,1,J+2)
      IF (MD(I).LT.0) P(I,1,J)=0.0
      IF (MD(I).LT.0) P(I,2,J)=0.0
      IF (MM(I).EQ.0) GO TO 32
      IF (MM(I).EQ.2) GO TO 32
      IF (MM(I).EQ.1) GO TO 26
      IF (MM(I).EQ.3) GO TO 27
      IF (MD(I).GT.I) P(I,2,J)=P(I,2,J)+S4*TH
      IF (MD(I).LT.I) P(MD(I),2,J)=P(MD(I),2,J)-S4*TH
      IF (MD(I).LT.I) GO TO 27
      GO TO 24
   32 P(I,1,J)=P(I,1,J)-BB*TH-PP(I,1,J)
      IF (MM(I).EQ.2) GO TO 28
   26 P(I,2,J)=P(I,2,J)-AA*TH-PP(I,2,J)+S4*TH
      IF (MM(I).EQ.0) GO TO 24
   27 P(I,1,J)=P(I,1,J)+DX*SS+DY*CC-PP(I,1,J+2)
      IF (MM(I).EQ.1) GO TO 24
   28 P(I,2,J)=P(I,2,J)-DX*CC+DY*SS-PP(I,2,J+2)
   24 CONTINUE
      IF (NCR.NE.0) GO TO 14
 2011 FORMAT (/' BLOCK NO.',I5,'    EDGE NO.',I5,
     1     '    BOUNDARY ELEMENTS',I6,'  -',I4/5X,
     2     'M   NO.  MM   MD      X',12X,'Y',14X,
     3     'BOUNDARY VALUES; X-LEFT X-RIGHT Y-LEFT '
     4     ,'Y-RIGHT          LENGTH  DIRECTION')
 2012 FORMAT (1H ,4I5,2F12.5,F17.5,3F13.5,F13.6,F8.1)
C
C  -------- FORM SIMULTANEOUS EQUATIONS --------
      WRITE(0,2102) 
 2102 FORMAT(/,'      FORMING SIMULTANEOUS EQUATIONS')
      NN=ND*4
      NM=NN+1
      DO 37 I=1,NN
      DO 37 J=1,NN
   37 G(I,J)=0.0
      DO 42 K=1,NE
      KA=JA(K)
      KB=JB(K)
      PR=PRR(K)
      EN=ENN(K)
      TH=THH(K)
      DO 42 J=KA,KB
      LF=J
      DO 44 I=KA,KB
      LBB=MM(I)
      LE=I
      IF(LF.NE.LE) GO TO 54
      IF(M(LF).GE.3) GO TO 54
      CALL ANALYT 
      GO TO 55
   54 CALL DISTRI
   55 DO 44 KT=1,2
      I1=4*I+KT-4
      I2=I1+2
      DO 45 KP=1,2
      DO 45 KQ=1,2
      JJ=4*J-6+2*KP+KQ
      IF (MM(I).EQ.4) GO TO 48
      IF (MM(I).EQ.5) GO TO 48
      IF (MM(I).EQ.1) GO TO 41
      IF (MM(I).EQ.3) GO TO 46
      G(I1,JJ)=QQ(KP,KQ,1,KT,1)
      IF (MM(I).EQ.2) GO TO 47
   41 G(I2,JJ)=QQ(KP,KQ,2,KT,1)
      IF (MM(I).EQ.0) GO TO 45
   46 G(I1,JJ)=QQ(KP,KQ,1,KT,2)/TH
      IF (MM(I).EQ.1) GO TO 45
   47 G(I2,JJ)=QQ(KP,KQ,2,KT,2)/TH
      GO TO 45
   48 I3=MD(I)*4+KT-4
      I4=I3+2
      IF (KT.EQ.1) KW=2
      IF (KT.EQ.2) KW=1
      IF (MM(I).EQ.5) GO TO 50
      IF (I.GT.MD(I)) GO TO 43
      G(I1,JJ)=QQ(KP,KQ,1,KT,1)
      G(I2,JJ)=QQ(KP,KQ,2,KT,1)
      G(I3,JJ)=-QQ(KP,KQ,1,KW,2)/TH
      G(I4,JJ)=-QQ(KP,KQ,2,KW,2)/TH
      GO TO 45
   43 G(I1,JJ)=-QQ(KP,KQ,1,KT,2)/TH
      G(I2,JJ)=-QQ(KP,KQ,2,KT,2)/TH
      G(I3,JJ)=-QQ(KP,KQ,1,KW,1)
      G(I4,JJ)=-QQ(KP,KQ,2,KW,1)
      GO TO 45
   50 G(I1,JJ)=QQ(KP,KQ,1,KT,1)
      IF (I.GT.MD(I)) GO TO 51
      G(I2,JJ)=QQ(KP,KQ,2,KT,1)
      G(I4,JJ)=-QQ(KP,KQ,2,KW,2)/TH
      GO TO 45
   51 G(I2,JJ)=-QQ(KP,KQ,2,KT,2)/TH
      G(I4,JJ)=-QQ(KP,KQ,2,KW,1)
   45 CONTINUE
      IF (J.EQ.KB) G(I1,NM)=P(I,1,KT)
   44 IF (J.EQ.KB) G(I2,NM)=P(I,2,KT)
   42 CONTINUE
      DO 65 J=1,NN
      B(J)=0.0
      DO 65 K=1,NN
   65 IF(ABS(G(J,K)).GT.B(J)) B(J)=ABS(G(J,K))
      DO 66 J=1,NN
      IF(B(J).LE.0.0) ILL=9000
      IF(ILL.NE.0) GO TO 14
      DO 66 K=1,NM
   66 G(J,K)=G(J,K)/B(J)
C
C  ------ SOLVE SIMULTANEOUS EQUATIONS ------
      ILL=0
      DO 81 I=1,NN
      WRITE(0,2103) I,NN
 2103 FORMAT(1H ,' SOLVING SIMULTANEOUS EQUATIONS',
     1  ' NO.='I6,'  /',I6)
      A5=0.0
      DO 82 J=I,NN
      IF(ABS(G(J,I)).GT.A5) IA=J
   82 IF(ABS(G(J,I)).GT.A5) A5=ABS(G(J,I))
      IF(A5.LE.0.00001) ILL=I
      IF(ILL.NE.0) GO TO 14
      DO 83 K=I,NM
      B5=G(I,K)
      G(I,K)=G(IA,K)
   83 G(IA,K)=B5
      II=I+1
      DO 84 L=II,NM
      G(I,L)=G(I,L)/G(I,I)
      DO 84 K=1,NN
   84 IF(K.NE.I) G(K,L)=G(K,L)-G(I,L)*G(K,I)
   81 CONTINUE
      DO 85 I=1,NN
   85 B(I)=G(I,NM)
      WRITE(16,2041)
      WRITE(16,2042) (I,B(I*4-3),B(I*4-2),
     1      B(I*4-1),B(I*4),I=1,ND)
 2041 FORMAT (/'  WEIGHTS OF FUNDAMENTAL SOLUTIONS;'
     1    ,'    ELEMENT NO.  X-LEFT X-RIGHT Y-LEFT '
     2    ,'Y-RIGHT')
 2042 FORMAT (1H ,I4,4F13.2,I5,4F13.2)
C
C  ----- CALCULATE STRESS AND DISPLACEMENT ----
      LBB=10
      DO 56 K=1,NE
      PR=PRR(K)
      EN=ENN(K)
      TH=THH(K)
      KA=JA(K)
      KB=JB(K)
      LA=1
      LB=NSP(K)
      IF (K.NE.1) LA=NSP(K-1)+1
      DO 56 J=KA,KB
      LF=J
      DO 52 I=KA,KB
      LE=I
      IF(LF.NE.LE) GO TO 57
      IF(M(LF).GE.3) GO TO 57
      CALL ANALYT 
      GO TO 58
   57 CALL DISTRI
   58 DO 53 KP=1,2
      DO 53 KQ=1,2
      JJ=4*J+2*KP+KQ-6
      DO 53 KS=1,2
      DO 53 KT=1,2
      PT(I,KS,KT)=PT(I,KS,KT)+QQ(KP,KQ,KS,KT,1)*B(JJ)
      PD(I,KS,KT)=PD(I,KS,KT)+QQ(KP,KQ,KS,KT,2)*B(JJ)/TH
   53 CONTINUE
   52 CONTINUE
      SF=SIN(F(J))
      CF=COS(F(J))
      IF (LB.EQ.0) GO TO 56
      DO 63 I=LA,LB
      UU= (SP(I,1)-AP(J,1))*CF+(SP(I,2)-AP(J,2))*SF
      VV=-(SP(I,1)-AP(J,1))*SF+(SP(I,2)-AP(J,2))*CF
      IF (M(J).EQ.1) UU=UU-R(J)
      IF (M(J).EQ.4) UU=UU-R(J)
      IF (M(J).EQ.2) UU=UU+R(J)
      IF (M(J).EQ.5) UU=UU+R(J)
      CALL FUNDA
      DO 63 KQ=1,2
      JX=4*J+KQ-4
      JY=4*J+KQ-2
      X=Q(1,1,KQ)*B(JX)+Q(1,2,KQ)*B(JY)
      Y=Q(2,1,KQ)*B(JX)+Q(2,2,KQ)*B(JY)
      XY=Q(3,1,KQ)*B(JX)+Q(3,2,KQ)*B(JY)
      SS=SF*SF
      SSS=2.0*SF*CF
      CC=CF*CF
      CCC=2.0*CC-1.0
      C(I,1)=C(I,1)+(X*CC+Y*SS+XY*SSS)/TH
      C(I,2)=C(I,2)+(X*SS+Y*CC-XY*SSS)/TH
      C(I,3)=C(I,3)-(-0.5*(X-Y)*SSS+XY*CCC)/TH
      C(I,4)=C(I,4)+((Q(4,1,KQ)*B(JX)+Q(4,2,KQ)*
     1    B(JY))*CF-(Q(5,1,KQ)*B(JX)+Q(5,2,KQ)
     2    *B(JY))*SF)/TH
   63 C(I,5)=C(I,5)+((Q(4,1,KQ)*B(JX)+Q(4,2,KQ)*
     1    B(JY))*SF+(Q(5,1,KQ)*B(JX)+Q(5,2,KQ)
     2    *B(JY))*CF)/TH
   56 CONTINUE
C
C  -------------- OUTPUT RESULT ----------------
      WRITE(16,2060) 
      DO 60 I=1,ND
   60 WRITE(16,2061) M(I),I,MM(I),MD(I),AP(I,1),
     1    AP(I,2),((PT(I,J,L),L=1,2),J=1,2),
     2    ((PD(I,J,L),L=1,2),J=1,2)
      IF(NS.EQ.0) GO TO 14
      WRITE(16,2062)
      DO 61 I=1,NS
      UU=(C(I,1)-C(I,2))*0.5
      VV=-C(I,3)
      H3=SQRT(UU**2+VV**2)
      H1=(C(I,1)+C(I,2))*0.5+H3
      H2=(C(I,1)+C(I,2))*0.5-H3
      CALL ARCTAN
      ANGLE=-FUV*90.0*ZI
   61 WRITE(16,2063) I,SP(I,1),SP(I,2),H1,H2,H3,
     1    ANGLE,(C(I,J),J=1,5)
 2060 FORMAT (//'  BOUNDARY ELEMENTS'/'  M NO. MM MD ',
     1    '   X',9X,'Y',10X,'TRACTIONS; X-LEFT X-RIGH',
     2    'T Y-LEFT Y-RIGHT   DISPLACEMENTS;  X-LEFT ',
     3    'X-RIGHT Y-LEFT Y-RIGHT')
 2061 FORMAT (1H ,I2,I5,I3,I5,2F12.5,4F11.3,4E13.5)
 2062 FORMAT (//'  INNER POINTS'/'  ANGLE IS THE ',
     1    'DIRECTION OF THE PRINCIPAL STRESS H1'/
     2    '    NO.   X',9X,'Y',10X,'PRINCIPAL STRESSES'
     3    ,' H1 H2 H3    ANGLE      STRESSES X Y XY'
     4    ,15X,'DISPLACEMENTS X Y')
 2063 FORMAT (1H ,I5,2F12.5,3F11.2,F8.2,3F11.2,2E13.5)
 2064 FORMAT (/'   ---------- WARNING POISSON''S RATIO'
     1    ,' >= 0.33 IN PLANE STRESS CONDITION, >= 0.2'
     2    ,'5 IN PLANE STRAIN CONDITION ----------')
 2099 FORMAT (//'  NCR =',I5,'     ILL =',I5)
 2096 FORMAT (/'  FORCE BALANCE      +X TRA.       '
     1   ,'-X TRA.      X REG.   X REG/TRA       +Y TRA.'
     2   ,'       -Y TRA.      Y REG.   Y REG/TRA')
 2097 FORMAT ('  BLOCK NO.',I3,F15.3,F14.3,F12.3,F10.3,
     1   F16.3,F14.3,F12.3,F10.3)
 2098 FORMAT ('  TOTAL       ',F15.3,F14.3,F12.3,F10.3,
     1   F16.3,F14.3,F12.3,F10.3)
   14 WRITE(16,2099) NCR,ILL
      SXT1=0.0
      SXT2=0.0
      SYT1=0.0
      SYT2=0.0
      REXS=0.0
      REYS=0.0
      DO 90 I=1,NE
      SXTB1(I)=0.0
      SXTB2(I)=0.0
      SYTB1(I)=0.0
      SYTB2(I)=0.0
      J1=JA(I)
      J2=JB(I)
      DO 91 J=J1,J2
      SS=SIN(F(J))
      CC=COS(F(J))
      P9X=R(J)*((PT(J,1,1)+PT(J,1,2))*CC-(PT(J,2,1)+PT(J,2,2))*SS)
      P9Y=R(J)*((PT(J,1,1)+PT(J,1,2))*SS+(PT(J,2,1)+PT(J,2,2))*CC)
      IF(P9X.GE.0.0) SXTB1(I)=SXTB1(I)+P9X
      IF(P9X.LT.0.0) SXTB2(I)=SXTB2(I)+P9X
      IF(P9Y.GE.0.0) SYTB1(I)=SYTB1(I)+P9Y
   91 IF(P9Y.LT.0.0) SYTB2(I)=SYTB2(I)+P9Y
      SXT1=SXT1+SXTB1(I)
      SXT2=SXT2+SXTB2(I)
      SYT1=SYT1+SYTB1(I)
   90 SYT2=SYT2+SYTB2(I)
      WRITE(16,2096)
      DO 92 I=1,NE
      RXTBS=SXTB1(I)+SXTB2(I)
      RYTBS=SYTB1(I)+SYTB2(I)
      ARXTBS=ABS(RXTBS)
      ARYTBS=ABS(RYTBS)
      PXT1=ABS(SXTB1(I))
      PXT2=ABS(SXTB2(I))
      PYT1=ABS(SYTB1(I))
      PYT2=ABS(SYTB2(I))
      IF (PXT1.LT.PXT2) PXT1=PXT2
      IF (PYT1.LT.PYT2) PYT1=PYT2
      IF(PXT1.GT.0.0001) GO TO 94
      XPA=9999.999  
      IF(ARXTBS.LT.0.0005) XPA=0.0
      GO TO 95
   94 XPA=ARXTBS/PXT1
   95 IF(PYT1.GT.0.0001) GO TO 96
      YPA=9999.999  
      IF(ARYTBS.LT.0.0005) YPA=0.0
      GO TO 92
   96 YPA=ARYTBS/PYT1
   92 WRITE(16,2097) I,SXTB1(I),SXTB2(I),RXTBS,XPA,
     1   SYTB1(I),SYTB2(I),RYTBS,YPA
      RXTS=SXT1+SXT2
      RYTS=SYT1+SYT2
      ARXTS=ABS(RXTS)
      ARYTS=ABS(RYTS)
      PXT1=ABS(SXT1)
      PXT2=ABS(SXT2)
      PYT1=ABS(SYT1)
      PYT2=ABS(SYT2)
      IF (PXT1.LT.PXT2) PXT1=PXT2
      IF (PYT1.LT.PYT2) PYT1=PYT2
      IF(PXT1.GT.0.0001) GO TO 97
      XPA=9999.999  
      IF(ARXTS.LT.0.0005) XPA=0.0
      GO TO 98
   97 XPA=ARXTS/PXT1
   98 IF(PYT1.GT.0.0001) GO TO 99
      YPA=9999.999  
      IF(ARYTS.LT.0.0005) YPA=0.0
      GO TO 93
   99 YPA=ARYTS/PYT1
   93 WRITE(16,2098) SXT1,SXT2,RXTS,XPA,SYT1,SYT2,RYTS,YPA
      IF(KPR.NE.0) WRITE(16,2064)
      CLOSE(15)
      CLOSE(16)
      STOP
      END
      SUBROUTINE FUNDA
      COMMON M(3000),R(3000),F(3000),AP(3000,2),CG(4,9,3),
     1   Q(5,2,2),QQ(2,2,2,2,2),ZP,ZI,TH,EN,PR,UU,VV,LE
     2   ,LF,LBB,FUV
C
C  -------- CALCULATE FUNDAMENTAL FIELD --------
      DO 100 I=1,5
      DO 100 J=1,2
      DO 100 N=1,2
  100 Q(I,J,N)=0.0
      PQ=1.0-PR
      PS=1.0+PR
      T=R(LF)*2.0
      IF (M(LF).EQ.0) T=R(LF)
      IF (M(LF).EQ.3) T=R(LF)
      UA=UU-T
      UB=UU+T
      RR=SQRT(UU**2+VV**2)
      WM=(3.0+PR)*0.25*ZI
      WN=(1.0-PR)*0.25*ZI
      WA=(PR-3.0)*(PR+1.0)*0.25*ZI/EN
      WB=(PR+1.0)*(PR+1.0)*0.25*ZI/EN
      IF (ABS(VV).GT.0.0005*T) GO TO 140
      IF (ABS(ABS(UU)-T).LT.0.0005*T) GO TO 145
      IF (LBB.EQ.3) GO TO 120
      BBB=ALOG(ABS(UB/UA))
      IF (M(LF).GT.2) GO TO 121
      Q(1,1,1)=-WM*(1.0-BBB*UA*0.5/T)
      Q(1,1,2)= WM*(1.0-BBB*UB*0.5/T)
      Q(2,1,1)= WN*(1.0-BBB*UA*0.5/T)
      Q(2,1,2)=-WN*(1.0-BBB*UB*0.5/T)
      Q(3,2,1)= WN*(1.0-BBB*UA*0.5/T)
      Q(3,2,2)=-WN*(1.0-BBB*UB*0.5/T)
      IF (ABS(UU).LT.T) Q(3,1,1)=UA*0.25/T
      IF (ABS(UU).LT.T) Q(3,1,2)=-UB*0.25/T
      IF (ABS(UU).LT.T) Q(1,2,1)=-UA*PR*0.25/T
      IF (ABS(UU).LT.T) Q(1,2,2)= UB*PR*0.25/T
      IF (ABS(UU).LT.T) Q(2,2,1)=-UA*0.25/T
      IF (ABS(UU).LT.T) Q(2,2,2)= UB*0.25/T
      GO TO 120
  121 Q(1,1,1)=ZI*(-2.0+(UA/T)*BBB)
      Q(1,1,2)=ZI*(2.0-(UB/T)*BBB)
      IF (ABS(UU).LT.T) Q(2,2,1)=0.5*(-UA/T)
      IF (ABS(UU).LT.T) Q(2,2,2)=0.5*(UB/T)
      IF (ABS(UU).LT.T) Q(3,1,1)=0.5*(UA/T)
      IF (ABS(UU).LT.T) Q(3,1,2)=0.5*(-UB/T)
      IF (ABS(UU).LT.T) Q(1,2,1)=0.5*(-UA/T)
      IF (ABS(UU).LT.T) Q(1,2,2)=0.5*(UB/T)
  120 IF (LBB.EQ.0) RETURN
      QQQ=UA*ALOG(ABS(UA))-UB*ALOG(ABS(UB))
      WWW=UA*UA*ALOG(ABS(UA))-UB*UB*ALOG(ABS(UB))
      IF (M(LF).GT.2) GO TO 122
      Q(4,1,1)=(-(0.5*WA*WWW+(WA-2.0*WB)*UU*T)
     1    +UA*(WA*QQQ+(WA-WB)*2.0*T))*0.5/T
      Q(4,1,2)=( (0.5*WA*WWW+(WA-2.0*WB)*UU*T)
     1    -UB*(WA*QQQ+(WA-WB)*2.0*T))*0.5/T
      Q(5,2,1)= WA*(-0.5*WWW/T-UU+(QQQ/T+2.0)*UA)*0.5
      Q(5,2,2)=-WA*(-0.5*WWW/T-UU+(QQQ/T+2.0)*UB)*0.5
      RETURN
  122 WX=0.5*ZI/EN/T
      Q(4,1,1)= WX*(-2.0*(QQQ+2.0*T)*UA+WWW+2.0*UU*T)
      Q(4,1,2)=-WX*(-2.0*(QQQ+2.0*T)*UB+WWW+2.0*UU*T)
      Q(5,2,1)= WX*(-2.0*(QQQ+PQ*T)*UA+WWW-2.0*UU*T*PR)
      Q(5,2,2)=-WX*(-2.0*(QQQ+PQ*T)*UB+WWW-2.0*UU*T*PR)
      WD=-ZP*UU
      WV=-ZP*(UU*UU+T*T)
      IF (UU.GT.T) WD=-ZP*T
      IF (UU.GT.T) WV=-2.0*ZP*UU*T
      IF (UU.LT.-T) WD=ZP*T
      IF (UU.LT.-T) WV=2.0*ZP*UU*T
      Q(5,1,1)= WX*PQ*(-WD*UA+0.5*WV)
      Q(5,1,2)=-WX*PQ*(-WD*UB+0.5*WV)
      Q(4,2,1)= WX*PQ*(WD*UA-0.5*WV)
      Q(4,2,2)=-WX*PQ*(WD*UB-0.5*WV)
      RETURN
  145 VV=-0.0005*T
  140 UU=UU+T
      CALL ARCTAN
      FA=FUV
      UU=UU-2.0*T
      CALL ARCTAN
      FB=FUV
      FBA=FB-FA
      SA=SIN(FA)
      SB=SIN(FB)
      SSS=SIN(2.0*FB)-SIN(2.0*FA)
      CCC=COS(2.0*FB)-COS(2.0*FA)
      AAA=ALOG(ABS(SB/SA))
      TTT=1.0/TAN(FB)-1.0/TAN(FA)
      IF (LBB.EQ.3) GO TO 130
      IF (M(LF).GT.2) GO TO 131
      W4=0.25*(WM-WN)
      W2=0.5*(WM+WN)
      Q(1,1,1)=( (WM*TTT+(1.5*WM-0.5*WN)*FBA+W4*SSS)*VV 
     1    +(WM*AAA+W4*CCC)*UA)*0.5/T
      Q(1,1,2)=(-(WM*TTT+(1.5*WM-0.5*WN)*FBA+W4*SSS)*VV
     1    -(WM*AAA+W4*CCC)*UB)*0.5/T
      Q(2,1,1)=(-(WN*TTT+W2*FBA+W4*SSS)*VV-
     1    (WN*AAA+W4*CCC)*UA)*0.5/T
      Q(2,1,2)=( (WN*TTT+W2*FBA+W4*SSS)*VV+
     1    (WN*AAA+W4*CCC)*UB)*0.5/T
      Q(3,1,1)=( (WM*AAA+W4*CCC)*VV-(W2*FBA+W4*SSS)*UA)
     1    *0.5/T
      Q(3,1,2)=(-(WM*AAA+W4*CCC)*VV+(W2*FBA+W4*SSS)*UB)
     1    *0.5/T
      Q(1,2,1)=( ((-WM+2.0*WN)*AAA-W4*CCC)*VV+
     1    ((0.5*WM-1.5*WN)*FBA+W4*SSS)*UA)*0.5/T
      Q(1,2,2)=(-((-WM+2.0*WN)*AAA-W4*CCC)*VV-
     1    ((0.5*WM-1.5*WN)*FBA+W4*SSS)*UB)*0.5/T
      Q(2,2,1)=( (-WN*AAA+W4*CCC)*VV+(W2*FBA-W4*SSS)
     1    *UA)*0.5/T
      Q(2,2,2)=(-(-WN*AAA+W4*CCC)*VV-(W2*FBA-W4*SSS)
     1    *UB)*0.5/T
      Q(3,2,1)=( (-WN*TTT+(0.5*WM-1.5*WN)*FBA+W4*SSS)
     1    *VV-(WN*AAA-W4*CCC)*UA)*0.5/T
      Q(3,2,2)=(-(-WN*TTT+(0.5*WM-1.5*WN)*FBA+W4*SSS)
     1    *VV+(WN*AAA-W4*CCC)*UB)*0.5/T
      GO TO 130
  131 Q(1,1,1)=ZI*(UA/T*(AAA+0.25*CCC)+VV/T*(1.5*FBA+
     1    0.25*SSS+TTT))
      Q(1,1,2)=ZI*(-UB/T*(AAA+0.25*CCC)-VV/T*(1.5*FBA+
     1    0.25*SSS+TTT))
      Q(2,1,1)=ZI*(-0.25*UA/T*CCC-0.5*VV/T*(FBA+0.5
     1    *SSS))
      Q(2,1,2)=ZI*(0.25*UB/T*CCC+0.5*VV/T*(FBA+0.5*SSS))
      Q(3,1,1)=ZI*(-0.5*UA/T*(FBA+0.5*SSS)+VV/T*(0.25
     1    *CCC+AAA))
      Q(3,1,2)=ZI*(0.5*UB/T*(FBA+0.5*SSS)-VV/T*(0.25
     1    *CCC+AAA))
      Q(1,2,1)=ZI/T*(0.5*UA*(FBA+0.5*SSS)-VV*(AAA+0.25
     1    *CCC))
      Q(1,2,2)=ZI/T*(-0.5*UB*(FBA+0.5*SSS)+VV*(AAA+0.25
     1    *CCC))
      Q(2,2,1)=ZI/T*(0.5*UA*(FBA-0.5*SSS)+0.25*VV*CCC)
      Q(2,2,2)=-ZI/T*(0.5*UB*(FBA-0.5*SSS)+0.25*VV*CCC)
      Q(3,2,1)=ZI/T*(0.5*VV*(FBA+0.5*SSS)+0.25*UA*CCC)
      Q(3,2,2)=-ZI/T*(0.5*VV*(FBA+0.5*SSS)+0.25*UB*CCC)
  130 IF (LBB.EQ.0) RETURN
      GGG=ALOG(ABS(SB/VV))/SB/SB-ALOG(ABS(SA/VV))/SA/SA
      HHH=1.0/SB/SB-1.0/SA/SA
      EEE=1.0/TAN(FB)*ALOG(ABS(SB/VV))-1.0/TAN(FA)
     1    *ALOG(ABS(SA/VV))
      IF (M(LF).GT.2) GO TO 133
      Q(4,1,1)=( (WA*(0.5*GGG+0.25*HHH)-WB*(AAA+0.5*HHH)
     1    )*VV-(WA*EEE+(WA-WB)*(TTT+FBA))*UA)*0.5*VV/T
      Q(4,1,2)=(-(WA*(0.5*GGG+0.25*HHH)-WB*(AAA+0.5*HHH)
     1    )*VV+(WA*EEE+(WA-WB)*(TTT+FBA))*UB)*0.5*VV/T
      Q(5,1,1)=(-(TTT+FBA)*VV-AAA*UA)*WB*0.5*VV/T
      Q(5,1,2)=( (TTT+FBA)*VV+AAA*UB)*WB*0.5*VV/T
      Q(4,2,1)=Q(5,1,1)
      Q(4,2,2)=Q(5,1,2)
      Q(5,2,1)=( (0.5*WA*GGG+0.25*WA*HHH+WB*AAA)*VV
     1    -(WA*(EEE+TTT)+(WA+WB)*FBA)*UA)*VV*0.5/T
      Q(5,2,2)=(-(0.5*WA*GGG+0.25*WA*HHH+WB*AAA)*VV
     1    +(WA*(EEE+TTT)+(WA+WB)*FBA)*UB)*VV*0.5/T
      RETURN
  133 VVV=(FB+0.5*ZP)/SB/SB-(FA+0.5*ZP)/SA/SA
      DDD=(FB+0.5*ZP)/TAN(FB)-(FA+0.5*ZP)/TAN(FA)
      Q(4,1,1)=VV*ZI/EN*(-0.5*VV/T*(GGG+0.5*HHH+PS*AAA)  
     1    +UA/T*(EEE+TTT+0.5*(3.0+PR)*FBA))
      Q(4,1,2)=VV*ZI/EN*(0.5*VV/T*(GGG+0.5*HHH+PS*AAA) 
     1    -UB/T*(EEE+TTT+0.5*(3.0+PR)*FBA))
      Q(5,1,1)=VV*ZI/EN*(-UA/T*(PQ*DDD+2.0*PR*AAA)+VV/T*
     1    (0.5*PQ*VVV-PS*FBA-0.5*(1.0+3.0*PR)*TTT))*0.5
      Q(5,1,2)=VV*ZI/EN*(UB/T*(PQ*DDD+2.0*PR*AAA)-VV/T*
     1    (0.5*PQ*VVV-PS*FBA-0.5*(1.0+3.0*PR)*TTT))*0.5
      Q(4,2,1)=0.5*ZI*VV/EN*(-UA/T*(-PQ*DDD+2.0*AAA)
     1    -VV/T*(0.5*PQ*VVV+PS*FBA+0.5*(3.0+PR)*TTT))
      Q(4,2,2)=0.5*ZI*VV/EN*(UB/T*(-PQ*DDD+2.0*AAA)
     1    +VV/T*(0.5*PQ*VVV+PS*FBA+0.5*(3.0+PR)*TTT))
      Q(5,2,1)=ZI*VV/EN*(-0.5*VV/T*(GGG-0.5*PR*HHH-
     1    PS*AAA)+UA/T*(EEE+0.5*PQ*(TTT+FBA)))
      Q(5,2,2)=ZI*VV/EN*(0.5*VV/T*(GGG-0.5*PR*HHH-
     1    PS*AAA)-UB/T*(EEE+0.5*PQ*(TTT+FBA)))
      RETURN
      END
      SUBROUTINE DISTRI
      COMMON M(3000),R(3000),F(3000),AP(3000,2),CG(4,9,3),
     1   Q(5,2,2),QQ(2,2,2,2,2),ZP,ZI,TH,EN,PR,UU,VV,LE
     2   ,LF,LBB,FUV
      DIMENSION QB(2,2,4,2)
C
C  ------ CALCULATE DISTRIBUTION ------
      CF=COS(F(LF))
      SF=SIN(F(LF))
      XX= (AP(LE,1)-AP(LF,1))*CF+(AP(LE,2)-AP(LF,2))*SF
      YY=-(AP(LE,1)-AP(LF,1))*SF+(AP(LE,2)-AP(LF,2))*CF
      IF (M(LF).EQ.1) XX=XX-R(LF)
      IF (M(LF).EQ.4) XX=XX-R(LF)
      IF (M(LF).EQ.2) XX=XX+R(LF)
      IF (M(LF).EQ.5) XX=XX+R(LF)
      SW=SIN(F(LF)-F(LE))
      CW=COS(F(LF)-F(LE))
      SS=SW*SW
      CC=CW*CW
      SSW=2.0*SW*CW
      CCW=2.0*CC-1.0
      DO 201 KP=1,2
      DO 201 KQ=1,2
      DO 201 KH=1,4
      QB(KP,KQ,KH,1)=0.0
  201 QB(KP,KQ,KH,2)=0.0
      RE=R(LF)
      IF (R(LE).GT.RE) RE=R(LE)
      RR=SQRT(XX*XX+YY*YY)
      NI=3
      IF (RR.GT.4.0*RE) NI=2
      IF (RR.GT.8.0*RE) NI=1
      NJ=NI*2+1
      DO 202 KS=1,NJ
      RRRR=R(LE)*CG(NI,KS,1)
      UU=XX+RRRR*CW
      VV=YY-RRRR*SW
      CALL FUNDA
      DO 202 KP=1,2
      DO 202 KQ=1,2
      WY=Q(1,KP,KQ)*SS+Q(2,KP,KQ)*CC-Q(3,KP,KQ)*SSW
      WX=0.5*(Q(1,KP,KQ)-Q(2,KP,KQ))*SSW-Q(3,KP,KQ)*CCW
      DY=Q(4,KP,KQ)*SW+Q(5,KP,KQ)*CW
      DX=Q(4,KP,KQ)*CW-Q(5,KP,KQ)*SW
      QB(KP,KQ,1,1)=QB(KP,KQ,1,1)+WX*CG(NI,KS,2)
      QB(KP,KQ,1,2)=QB(KP,KQ,1,2)+WY*CG(NI,KS,2)
      QB(KP,KQ,2,1)=QB(KP,KQ,2,1)+WX*CG(NI,KS,3)
      QB(KP,KQ,2,2)=QB(KP,KQ,2,2)+WY*CG(NI,KS,3)
      QB(KP,KQ,3,1)=QB(KP,KQ,3,1)+DX*CG(NI,KS,2)
      QB(KP,KQ,3,2)=QB(KP,KQ,3,2)+DY*CG(NI,KS,2)
      QB(KP,KQ,4,1)=QB(KP,KQ,4,1)+DX*CG(NI,KS,3)
  202 QB(KP,KQ,4,2)=QB(KP,KQ,4,2)+DY*CG(NI,KS,3)
      DO 204 KP=1,2
      DO 204 KQ=1,2
      DO 204 KS=1,2
      QQ(KP,KQ,KS,1,1)=(QB(KP,KQ,1,KS)-QB(KP,KQ,2,KS)
     1    *3.0)*0.5
      QQ(KP,KQ,KS,2,1)=(QB(KP,KQ,1,KS)+QB(KP,KQ,2,KS)
     1    *3.0)*0.5
      QQ(KP,KQ,KS,1,2)=(QB(KP,KQ,3,KS)-QB(KP,KQ,4,KS)
     1    *3.0)*0.5
  204 QQ(KP,KQ,KS,2,2)=(QB(KP,KQ,3,KS)+QB(KP,KQ,4,KS)
     1    *3.0)*0.5
      RETURN
      END
      SUBROUTINE ARCTAN
      COMMON M(3000),R(3000),F(3000),AP(3000,2),CG(4,9,3),
     1   Q(5,2,2),QQ(2,2,2,2,2),ZP,ZI,TH,EN,PR,UU,VV,LE
     2   ,LF,LBB,FUV
C
C  --------  CALCULATE DIRECTION --------
      IF (ABS(UU).LE.0.00001) GO TO 300
      FUV=ATAN(VV/UU)
      IF (UU.GT.0.0) RETURN
      FUV=FUV+ZP
      IF (VV.LT.0.0) FUV=FUV-ZP*2.0
      RETURN
  300 FUV=ZP*0.5
      IF (VV.LT.0.0) FUV=FUV-ZP
      RETURN
      END
      SUBROUTINE CONCEN
      COMMON M(3000),R(3000),F(3000),AP(3000,2),CG(4,9,3),
     1   Q(5,2,2),QQ(2,2,2,2,2),ZP,ZI,TH,EN,PR,UU,VV,LE
     2   ,LF,LBB,FUV
C
C  -------- CALCULATE CONCENTRATED FORCE -------
      DO 400 II=1,5
      DO 400 JJ=1,2
  400 Q(II,JJ,1)=0.0
      IF(ABS(UU)+ABS(VV).LT.0.0001*R(LF)) VV=-0.0001*R(LF)
      RR=SQRT(UU*UU+VV*VV)
      SS=VV/RR
      CC=UU/RR
      AA=-2.0*ZI/EN
      BB=-AA*PR
      SSS=SS*SS
      CCC=CC*CC
      Q(1,1,1)=-2.0*ZI*CCC*CC/RR
      Q(2,1,1)=-2.0*ZI*SSS*CC/RR
      Q(3,1,1)= 2.0*ZI*SS*CCC/RR
      Q(1,2,1)=-2.0*ZI*SS*CCC/RR
      Q(2,2,1)=-2.0*ZI*SSS*SS/RR
      Q(3,2,1)= 2.0*ZI*SSS*CC/RR
      CALL ARCTAN
      IF (FUV.GT.3.141593) FUV=-FUV
      AAA=ALOG(RR)
      Q(4,1,1)=AA*AAA+0.5*(AA-BB)*SSS
      Q(5,2,1)=AA*AAA+0.5*(AA-BB)*CCC
      Q(5,1,1)=0.5*(AA+BB)*(FUV+0.5*ZP)-
     1    0.5*(AA-BB)*SS*CC
      Q(4,2,1)=-0.5*(AA+BB)*(FUV+0.5*ZP)-
     1    0.5*(AA-BB)*SS*CC
      RETURN
      END
      SUBROUTINE ANALYT
      COMMON M(3000),R(3000),F(3000),AP(3000,2),CG(4,9,3),
     1   Q(5,2,2),QQ(2,2,2,2,2),ZP,ZI,TH,EN,PR,UU,VV,LE
     2   ,LF,LBB,FUV
C
C  --- ANALYTICAL INTEGRATION FOR IDENTICAL ELEMENT ---
      WN=(1.0-PR)*0.25*ZI
      WA=(PR-3.0)*(1.0+PR)*0.25*ZI/EN
      WB=(1.0+PR)*(1.0+PR)*0.25*ZI/EN
      DO 501 KP=1,2
      DO 501 KQ=1,2
      DO 501 KS=1,2
      DO 501 J1=1,2
      DO 501 J2=1,2
  501 QQ(KP,KQ,KS,J1,J2)=0.0
      T=2.0*R(LF)
      IF(M(LF).EQ.0) T=R(LF)
      WLT=ALOG(T)
      WL2=ALOG(2.0)
      WL2T=WL2+WLT
      IF(M(LF).EQ.1) GO TO 502
      IF(M(LF).EQ.2) GO TO 503
      QQ(1,1,1,1,1)=0.5
      QQ(2,1,1,1,1)=WN
      QQ(2,2,1,1,1)=2.0*WN
      QQ(1,2,1,2,1)=0.5
      QQ(2,1,1,2,1)=-2.0*WN
      QQ(2,2,1,2,1)=-WN
      QQ(1,1,2,1,1)=-WN
      QQ(1,2,2,1,1)=-2.0*WN
      QQ(2,1,2,1,1)=0.5
      QQ(1,1,2,2,1)=2.0*WN
      QQ(1,2,2,2,1)=WN
      QQ(2,2,2,2,1)=0.5
      QQ(1,1,1,1,2)=T*((WL2T-2.25)*WA+WB)
      QQ(1,2,1,1,2)=T*((WL2T-0.75)*WA+WB)
      QQ(1,1,1,2,2)=T*((WL2T-0.75)*WA+WB)
      QQ(1,2,1,2,2)=T*((WL2T-2.25)*WA+WB)
      QQ(2,1,2,1,2)=T*(WL2T-2.25)*WA
      QQ(2,2,2,1,2)=T*(WL2T-0.75)*WA
      QQ(2,1,2,2,2)=T*(WL2T-0.75)*WA
      QQ(2,2,2,2,2)=T*(WL2T-2.25)*WA
      RETURN
  502 QQ(1,1,1,1,1)=0.5
      QQ(2,1,1,1,1)=2.0*WN
      QQ(2,2,1,1,1)=4.0*WN*(1.-WL2)
      QQ(1,1,1,2,1)=0.25
      QQ(1,2,1,2,1)=0.25
      QQ(2,1,1,2,1)=WN*(-3.0+2.0*WL2)
      QQ(2,2,1,2,1)=WN*(-3.0+6.0*WL2)
      QQ(1,1,2,1,1)=-2.0*WN
      QQ(1,2,2,1,1)=4.0*WN*(-1.0+WL2)
      QQ(2,1,2,1,1)=0.5
      QQ(1,1,2,2,1)=WN*(3.0-2.0*WL2)
      QQ(1,2,2,2,1)=WN*(3.0-6.0*WL2)
      QQ(2,1,2,2,1)=0.25
      QQ(2,2,2,2,1)=0.25
      QQ(1,1,1,1,2)=T*((2.*WL2T+WLT-5.)*WA/3.+WB)
      QQ(1,2,1,1,2)=T*((-2.*WL2T+5.*WLT+2.)*WA/3.+WB)
      QQ(1,1,1,2,2)=T*((2.*WL2T+WLT-5.)*WA/3.+WB)
      QQ(1,2,1,2,2)=T*((10.*WL2T-7.*WLT-10.)*WA/3.+WB)
      QQ(2,1,2,1,2)=T*(2.*WL2T+WLT-5.)*WA/3.
      QQ(2,2,2,1,2)=T*(-2.*WL2T+5.*WLT+2.)*WA/3.
      QQ(2,1,2,2,2)=T*(2.*WL2T+WLT-5.)*WA/3.
      QQ(2,2,2,2,2)=T*(10.*WL2T-7.*WLT-10.)*WA/3.
      RETURN
  503 QQ(1,1,1,1,1)=0.25
      QQ(1,2,1,1,1)=0.25
      QQ(2,1,1,1,1)=WN*(3.-6.*WL2)
      QQ(2,2,1,1,1)=WN*(3.-2.*WL2)
      QQ(1,2,1,2,1)=0.5
      QQ(2,1,1,2,1)=4.*WN*(-1.+WL2)
      QQ(2,2,1,2,1)=-2.*WN
      QQ(1,1,2,1,1)=WN*(-3.+6.*WL2)
      QQ(1,2,2,1,1)=WN*(-3.+2.*WL2)
      QQ(2,1,2,1,1)=0.25
      QQ(2,2,2,1,1)=0.25
      QQ(1,1,2,2,1)=4.*WN*(1.-WL2)
      QQ(1,2,2,2,1)=2.*WN
      QQ(2,2,2,2,1)=0.5
      QQ(1,1,1,1,2)=T*((10.*WL2T-7.*WLT-10.)*WA/3.+WB)
      QQ(1,2,1,1,2)=T*((2.*WL2T+WLT-5.)*WA/3.+WB)
      QQ(1,1,1,2,2)=T*((-2.*WL2T+5.*WLT+2.)*WA/3.+WB)
      QQ(1,2,1,2,2)=T*((2.*WL2T+WLT-5.)*WA/3.+WB)
      QQ(2,1,2,1,2)=T*(10.*WL2T-7.*WLT-10.)*WA/3.
      QQ(2,2,2,1,2)=T*(2.*WL2T+WLT-5.)*WA/3.
      QQ(2,1,2,2,2)=T*(-2.*WL2T+5.*WLT+2.)*WA/3.
      QQ(2,2,2,2,2)=T*(2.*WL2T+WLT-5.)*WA/3.
      RETURN
      END
